<?php
global $NAMESPACE;
// ==== WSDL TYPES DECLARATION =================================================

// ---- int[] ------------------------------------------------------------------

$server->wsdl->addComplexType(
    'intArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:int[]')
    ),
    'xsd:int'
);

// ---- string[] ------------------------------------------------------------------

$server->wsdl->addComplexType(
    'stringArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:string[]')
    ),
    'xsd:string'
);




// ---- Peer -------------------------------------------------------------------

$server->wsdl->addComplexType(
    'Peer',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'            => array('name'=>'id','type'=>'xsd:int'),
        'name'          => array('name'=>'name','type'=>'xsd:string'),
        'accountcode'   => array('name'=>'accountcode','type'=>'xsd:string'),
        'amaflags'      => array('name'=>'amaflags','type'=>'xsd:string'),
        'auth'          => array('name'=>'auth','type'=>'xsd:string'),
        'callerid'      => array('name'=>'callerid','type'=>'xsd:string'),
        'context'       => array('name'=>'context','type'=>'xsd:string'),
        'peercontext'   => array('name'=>'peercontext','type'=>'xsd:string'),
        'defaultip'     => array('name'=>'defaultip','type'=>'xsd:string'),
        'host'          => array('name'=>'host','type'=>'xsd:string'),
        'inkeys'        => array('name'=>'inkeys','type'=>'xsd:string'),
        'outkey'        => array('name'=>'outkey','type'=>'xsd:string'),
        'language'      => array('name'=>'language','type'=>'xsd:string'),
        'mailbox'       => array('name'=>'mailbox','type'=>'xsd:string'),
        'permit'        => array('name'=>'permit','type'=>'xsd:string'),
        'deny'          => array('name'=>'deny','type'=>'xsd:string'),
        'mask'          => array('name'=>'mask','type'=>'xsd:string'),
        'port'          => array('name'=>'port','type'=>'xsd:string'), //modified FROM "port" to "ports" for an unknown XML SOAP error
        'qualify'       => array('name'=>'qualify','type'=>'xsd:string'),
        'secret'        => array('name'=>'secret','type'=>'xsd:string'),
        'trunk'         => array('name'=>'trunk','type'=>'xsd:string'),
        'type'          => array('name'=>'type','type'=>'xsd:string'),
        'username'      => array('name'=>'username','type'=>'xsd:string'),
        'disallow'      => array('name'=>'disallow','type'=>'xsd:string'),
        'allow'         => array('name'=>'allow','type'=>'xsd:string'),
        'musiconhold'   => array('name'=>'musiconhold','type'=>'xsd:string'),
        'regseconds'    => array('name'=>'regseconds','type'=>'xsd:int'),
        'ipaddr'        => array('name'=>'ipaddr','type'=>'xsd:string'),
        'regexten'      => array('name'=>'regexten','type'=>'xsd:string'),
        'notransfer'    => array('name'=>'notransfer','type'=>'xsd:string'),
        'timezone'      => array('name'=>'timezone','type'=>'xsd:string'),
        'jitterbuffer'  => array('name'=>'jitterbuffer','type'=>'xsd:string'),
        'sendani'       => array('name'=>'sendani','type'=>'xsd:string'),
        'md5secret'     => array('name'=>'md5secret','type'=>'xsd:string'),
        'pickupgroup'   => array('name'=>'pickupgroup','type'=>'xsd:string'),
        'canreinvite'   => array('name'=>'canreinvite','type'=>'xsd:string'),
        'dtmfmode'      => array('name'=>'dtmfmode','type'=>'xsd:string'),
        'nat'           => array('name'=>'nat','type'=>'xsd:string'),
        'callgroup'     => array('name'=>'callgroup','type'=>'xsd:int'),
        'insecure'      => array('name'=>'insecure','type'=>'xsd:string'),
        'protocol'      => array('name'=>'protocol','type'=>'xsd:int')
    )
);

// ---- Peer[] -----------------------------------------------------------------

$server->wsdl->addComplexType(
    'PeerArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Peer[]')),
    'tns:Peer'
);



// ---- Entity -----------------------------------------------------------------

$server->wsdl->addComplexType(
    'Entity',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'            => array('name'=>'id','type'=>'xsd:int'),
        'type'          => array('name'=>'type','type'=>'xsd:int'),
        'key'           => array('name'=>'key','type'=>'xsd:int')
    )
);

// ---- Entity[] ---------------------------------------------------------------

$server->wsdl->addComplexType(
    'EntityArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Entity[]')),
    'tns:Entity'
);

// ---- Extension -----------------------------------------------------------------

$server->wsdl->addComplexType(
    'Extension',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'            => array('name'=>'id','type'=>'xsd:int'),
        'context'       => array('name'=>'context','type'=>'xsd:string'),
        'exten'         => array('name'=>'exten','type'=>'xsd:string'),
        'priority'      => array('name'=>'priority','type'=>'xsd:int'),
        'app'           => array('name'=>'app','type'=>'xsd:string'),
        'appdata'       => array('name'=>'appdata','type'=>'xsd:string'),
        'type'          => array('name'=>'type','type'=>'xsd:int')   //added field: specify the type of extensions
    )
);

// ---- Extension[] ---------------------------------------------------------------

$server->wsdl->addComplexType(
    'ExtensionArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Extension[]')),
    'tns:Extension'
);



// ---- ExtensionType ----------------------------------------------------------

$server->wsdl->addComplexType(
    'ExtensionType',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'              => array('name'=>'id','type'=>'xsd:int'),
        'name'            => array('name'=>'name','type'=>'xsd:string'),
        'technology_type' => array('name'=>'technology_type','type'=>'xsd:int'),
        'app'             => array('name'=>'app','type'=>'xsd:string'),
        'appdata'         => array('name'=>'appdata','type'=>'xsd:string')
    )
);

// ---- ExtensionTypeArray[] ---------------------------------------------------

$server->wsdl->addComplexType(
    'ExtensionTypeArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:ExtensionType[]')
    ),
    'tns:ExtensionType'
);




// ---- Group ------------------------------------------------------------------

$server->wsdl->addComplexType(
    'Group',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'          => array('name'=>'id','type'=>'xsd:int'),
        'name'        => array('name'=>'name','type'=>'xsd:string'),
        'type'        => array('name'=>'type','type'=>'xsd:int'),
        'entity'      => array('name'=>'entity','type'=>'tns:intArray'),
        'right'      => array('name'=>'right','type'=>'tns:intArray')
    )
);

// ---- Group[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'GroupArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Group[]')
    ),
    'tns:Group'
);




// ---- Right ------------------------------------------------------------------

$server->wsdl->addComplexType(
    'Right',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'          => array('name'=>'id','type'=>'xsd:int'),
        'name'        => array('name'=>'name','type'=>'xsd:string'),
        'group'       => array('name'=>'group','type'=>'tns:intArray'),
        'application' => array('name'=>'application','type'=>'tns:intArray'),
        'action'        => array('name'=>'action',       'type'=>'xsd:int'),
        'action_option' => array('name'=>'action_option','type'=>'xsd:string')
    )
);

// ---- Right[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'RightArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Right[]')
    ),
    'tns:Right'
);

// ---- Application ------------------------------------------------------------

$server->wsdl->addComplexType(
    'Application',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'          => array('name'=>'id','type'=>'xsd:int'),
        'name'        => array('name'=>'name','type'=>'xsd:string'),
        'context'     => array('name'=>'context','type'=>'xsd:string'),
        'description' => array('name'=>'description','type'=>'xsd:string'),
        'default'     => array('name'=>'default','type'=>'xsd:int')
    )
);

// ---- Application[] ----------------------------------------------------------

$server->wsdl->addComplexType(
    'ApplicationArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Application[]')
    ),
    'tns:Application'
);



// ---- Client -----------------------------------------------------------------

$server->wsdl->addComplexType(
    'Client',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'          => array('name'=>'id','type'=>'xsd:int'),
        'type'        => array('name'=>'type','type'=>'xsd:int'),
        'name'        => array('name'=>'name','type'=>'xsd:string'),
        'surname'     => array('name'=>'surname','type'=>'xsd:string'),
        'email'       => array('name'=>'email','type'=>'xsd:string'),
        'username'    => array('name'=>'username','type'=>'xsd:string'),
        'password'    => array('name'=>'password','type'=>'xsd:string'),
        'peer'        => array('name'=>'peer','type'=>'tns:Peer'),
        'exten'       => array('name'=>'exten','type'=>'tns:ExtensionArray'),
        'groups'      => array('name'=>'groups','type'=>'tns:intArray'),
        'voicemail'   => array('name'=>'voicemail','type'=>'tns:VoiceMail')
    )
);

// ---- Client[] ---------------------------------------------------------------

$server->wsdl->addComplexType(
    'ClientArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Client[]')
    ),
    'tns:Client'
);

// ---- Department -------------------------------------------------------------

$server->wsdl->addComplexType(
    'Department',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'          => array('name'=>'id','type'=>'xsd:int'),
        'name'        => array('name'=>'name','type'=>'xsd:string'),
        'shortcut'    => array('name'=>'surname','type'=>'xsd:int'),
        'inkey'       => array('name'=>'inkey','type'=>'xsd:string'),
        'peer'        => array('name'=>'peer','type'=>'tns:Peer'),
        'exten'       => array('name'=>'exten','type'=>'tns:ExtensionArray'),
        'groups'      => array('name'=>'groups','type'=>'tns:intArray')
    )
);

// ---- Department[] --------------------------------------------------------------

$server->wsdl->addComplexType(
    'DepartmentArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Department[]')
    ),
    'tns:Department'
);

// ---- Resource ---------------------------------------------------------------

$server->wsdl->addComplexType(
    'Resource',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'          => array('name'=>'id','type'=>'xsd:int'),
        'name'        => array('name'=>'name','type'=>'xsd:string'),
        'type'        => array('name'=>'type','type'=>'xsd:int'),
        'opcode'      => array('name'=>'opcode','type'=>'xsd:string'),
        'peer'        => array('name'=>'peer','type'=>'tns:Peer'),
        'exten'       => array('name'=>'exten','type'=>'tns:ExtensionArray'),
        'groups'       => array('name'=>'groups','type'=>'tns:intArray')
    )
);

// ---- Resource[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'ResourceArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Resource[]')
    ),
    'tns:Resource'
);

// ---- PhoneNumber ------------------------------------------------------------

$server->wsdl->addComplexType(
    'PhoneNumber',
    'complexType',
    'struct',
    'all',
    '$NAMESPACE',
    array(
        'id'    => array('name'=>'id','type'=>'xsd:int'),
        'name'  => array('name'=>'name','type'=>'xsd:string'),
        'exten' => array('name'=>'exten','type'=>'tns:ExtensionArray'),
        'groups'       => array('name'=>'groups','type'=>'tns:intArray')
    )
);

// ---- PhoneNumber[] ----------------------------------------------------------

$server->wsdl->addComplexType(
    'PhoneNumberArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:PhoneNumber[]')),
    'tns:PhoneNumber'
);


// ---- Queue ------------------------------------------------------------------

$server->wsdl->addComplexType(
    'Queue',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'                  => array('name'=>'id','type'=>'xsd:int'),
        'name'                => array('name'=>'name','type'=>'xsd:string'),
        'strategy'            => array('name'=>'strategy','type'=>'xsd:string'),
        'music'               => array('name'=>'music','type'=>'xsd:string'),
        'announce-frequency'  => array('name'=>'announce-frequency','type'=>'xsd:int'),
        'announce-holdtime'   => array('name'=>'announce-holdtime','type'=>'xsd:string'),
        'joinempty'           => array('name'=>'joinempty','type'=>'xsd:string'),
        'member'              => array('name'=>'member','type'=>'tns:intArray')
    )
);

// ---- Queue[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'QueueArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Queue[]')
    ),
    'tns:Queue'
);

// ---- Ivr --------------------------------------------------------------------

$server->wsdl->addComplexType(
    'Ivr',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'                  => array('name'=>'id','type'=>'xsd:int'),
        'name'                => array('name'=>'name','type'=>'xsd:string'),
        'rootnode'            => array('name'=>'rootnode','type'=>'xsd:int')
    )
);

// ---- Ivr[] ------------------------------------------------------------------

$server->wsdl->addComplexType(
    'IvrArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Ivr[]')
    ),
    'tns:Ivr'
);


// ---- IvrNode ----------------------------------------------------------------

$server->wsdl->addComplexType(
    'IvrNode',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'                  => array('name'=>'id','type'=>'xsd:int'),
        'name'                => array('name'=>'name','type'=>'xsd:string'),
        'parent'            => array('name'=>'parent','type'=>'xsd:int'),
        'order'               => array('name'=>'order','type'=>'xsd:int'),
        'key'               => array('name'=>'key','type'=>'xsd:string'),
        'audio'               => array('name'=>'audio','type'=>'xsd:string'),
        'dial'               => array('name'=>'dial','type'=>'xsd:int'),
        'queue'               => array('name'=>'queue','type'=>'xsd:int'),
        'macro'               => array('name'=>'macro','type'=>'xsd:int'),
        'goto'               => array('name'=>'goto','type'=>'xsd:string'),
        'taudio'               => array('name'=>'taudio','type'=>'xsd:string'),
        'tdial'               => array('name'=>'tdial','type'=>'xsd:int'),
        'tqueue'               => array('name'=>'tqueue','type'=>'xsd:int'),
        'trepeat'               => array('name'=>'trepeat','type'=>'xsd:int'),
        'iaudio'               => array('name'=>'iaudio','type'=>'xsd:string'),
        'idial'               => array('name'=>'idial','type'=>'xsd:int'),
        'iqueue'               => array('name'=>'iqueue','type'=>'xsd:int'),
        'irepeat'               => array('name'=>'irepeat','type'=>'xsd:int')
    )
);

// ---- IvrNode[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'IvrNodeArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:IvrNode[]')
    ),
    'tns:IvrNode'
);



// ---- Option ------------------------------------------------------------------

$server->wsdl->addComplexType(
    'Option',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'                  => array('name'=>'id',       'type'=>'xsd:int'),
        'name'                => array('name'=>'name',     'type'=>'xsd:string'),
        'value'               => array('name'=>'value',    'type'=>'xsd:string'),
        'category'            => array('name'=>'category', 'type'=>'xsd:string'),
        'default'             => array('name'=>'default',  'type'=>'xsd:string'),
        'valuelist'           => array('name'=>'valuelist','type'=>'xsd:string'),
        'type'                => array('name'=>'type',     'type'=>'xsd:string'),
        'comment'             => array('name'=>'comment',  'type'=>'xsd:string'),
        'commented'           => array('name'=>'commented','type'=>'xsd:int')
    )
);

// ---- Options[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'OptionArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Option[]')
    ),
    'tns:Option'
);

// ---- ISDN Card --------------------------------------------------------------

$server->wsdl->addComplexType(
    'Card',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'                  => array('name'=>'id',      'type'=>'xsd:int'),
        'name'                => array('name'=>'name',    'type'=>'xsd:string'),
        'ports'                => array('name'=>'ports',    'type'=>'xsd:int'),
        'driver'                => array('name'=>'driver',    'type'=>'xsd:string')
    )
);

// ---- ISDN Card[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'CardArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Card[]')
    ),
    'tns:Card'
);

// ---- ISDN Port --------------------------------------------------------------

$server->wsdl->addComplexType(
    'Port',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'                  => array('name'=>'id',      'type'=>'xsd:int'),
        'port'                => array('name'=>'port',    'type'=>'xsd:int'),
        'layermask'           => array('name'=>'layermask','type'=>'xsd:string'),
        'protocol'            => array('name'=>'protocol',    'type'=>'xsd:string'),
        'card'                => array('name'=>'card',    'type'=>'xsd:int'),
        'card_id'             => array('name'=>'card',    'type'=>'xsd:int'),
        'available'           => array('name'=>'available','type'=>'xsd:int')
    )
);

// ---- ISDN Port[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'PortArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Port[]')
    ),
    'tns:Port'
);

// ---- ISDN Group --------------------------------------------------------------

$server->wsdl->addComplexType(
    'IsdnGroup',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'        => array('name'=>'id',       'type'=>'xsd:int'),
        'name'      => array('name'=>'name',     'type'=>'xsd:string'),
        'trunk_order'=> array('name'=>'trunk_order','type'=>'xsd:int'),
        'msns'      => array('name'=>'msns',     'type'=>'tns:IsdnPhoneNumberArray'),
        'port'      => array('name'=>'port',     'type'=>'tns:intArray'),
        'option'    => array('name'=>'option',   'type'=>'tns:IsdnOptionArray')
    )
);

// ---- ISDN Group[] -------------------------------------------------------------

$server->wsdl->addComplexType(
    'IsdnGroupArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:IsdnGroup[]')
    ),
    'tns:IsdnGroup'
);

// ---- ISDN Option --------------------------------------------------------

$server->wsdl->addComplexType(
    'IsdnOption',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'          => array('name'=>'id',   'type'=>'xsd:int'),
        'value'       => array('name'=>'value','type'=>'xsd:string')
    )
);

// ---- ISDN Port Group[] ------------------------------------------------------

$server->wsdl->addComplexType(
    'IsdnOptionArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:IsdnOption[]')
    ),
    'tns:IsdnOption'
);

// ---- Action --------------------------------------------------------

$server->wsdl->addComplexType(
    'Action',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'       => array('name'=>'id',   'type'=>'xsd:int'),
        'name'     => array('name'=>'name','type'=>'xsd:string'),
        'fax'      => array('name'=>'fax',   'type'=>'xsd:int'),
        'app'      => array('name'=>'app','type'=>'tns:stringArray'),
        'appdata'  => array('name'=>'appdata','type'=>'tns:stringArray')
    )
);

// ---- Action[] ------------------------------------------------------

$server->wsdl->addComplexType(
    'ActionArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Action[]')
    ),
    'tns:Action'
);

// ---- ISDN PhoneNumber --------------------------------------------------------

$server->wsdl->addComplexType(
    'IsdnPhoneNumber',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'            => array('name'=>'id',           'type'=>'xsd:int'),
        'number'        => array('name'=>'number',       'type'=>'xsd:string'),
        'group'         => array('name'=>'group',        'type'=>'xsd:int'),
        'fax'           => array('name'=>'fax',          'type'=>'xsd:int'),
        'action'        => array('name'=>'action',       'type'=>'xsd:int'),
        'action_option' => array('name'=>'action_option','type'=>'xsd:string')
    )
);

// ---- ISDN PhoneNumber[] ------------------------------------------------------

$server->wsdl->addComplexType(
    'IsdnPhoneNumberArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:IsdnPhoneNumber[]')
    ),
    'tns:IsdnPhoneNumber'
);

// ---- VoiceMail --------------------------------------------------------------

$server->wsdl->addComplexType(
    'VoiceMail',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'mailbox'     => array('name'=>'mailbox',     'type'=>'xsd:int'),
        'fullname'    => array('name'=>'fullname',    'type'=>'xsd:string'),
        'password'    => array('name'=>'password',    'type'=>'xsd:string'),
        'email'       => array('name'=>'email',       'type'=>'xsd:string'),
        'attach'      => array('name'=>'attach',      'type'=>'xsd:string'),
        'saycid'      => array('name'=>'saycid',      'type'=>'xsd:string'),
        'hidefromdir' => array('name'=>'hidefromdir', 'type'=>'xsd:string')
    )
);

// ---- VoiceMail[] ------------------------------------------------------

$server->wsdl->addComplexType(
    'VoiceMailArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:VoiceMail[]')
    ),
    'tns:VoiceMail'
);



// ---- Directory --------------------------------------------------------------

$server->wsdl->addComplexType(
    'Directory',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'name'        => array('name'=>'name',     'type'=>'xsd:string'),
        'username'    => array('name'=>'username', 'type'=>'xsd:string'),
        'status'      => array('name'=>'status',   'type'=>'xsd:string')
    )
);

// ---- Directory[] ------------------------------------------------------

$server->wsdl->addComplexType(
    'DirectoryArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Directory[]')
    ),
    'tns:Directory'
);

// ---- User --------------------------------------------------------------

$server->wsdl->addComplexType(
    'User',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'id'        => array('name'=>'id',       'type'=>'xsd:int'),
        'fullname'  => array('name'=>'fullname', 'type'=>'xsd:string'),
        'username'  => array('name'=>'username', 'type'=>'xsd:string'),
        'password'  => array('name'=>'password', 'type'=>'xsd:string'),
        'lang'      => array('name'=>'lang',     'type'=>'xsd:string'),
        'entity_id' => array('name'=>'entity_id','type'=>'xsd:int'),
        'exten'     => array('name'=>'exten',    'type'=>'xsd:string'),
        'protocol'  => array('name'=>'protocol', 'type'=>'xsd:int'),
        'type'      => array('name'=>'type',     'type'=>'xsd:int')
    )
);

// ---- User[] ------------------------------------------------------

$server->wsdl->addComplexType(
    'UserArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:User[]')
    ),
    'tns:User'
);

// ---- CDR Request (call detail report)------------------------------------------------

$server->wsdl->addComplexType(
    'CdrRequest',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'source'  => array('name'=>'source', 'type'=>'xsd:string'),
        'type'  => array('name'=>'type', 'type'=>'xsd:string'),
        'search'  => array('name'=>'search', 'type'=>'xsd:string'),
        'from'  => array('name'=>'from', 'type'=>'xsd:string'),
        'to'  => array('name'=>'to', 'type'=>'xsd:string'),
        'orderBy'  => array('name'=>'orderBy', 'type'=>'xsd:string'),
        'page'  => array('name'=>'page', 'type'=>'xsd:int')
    )
);

// ---- CDR (call detail report)------------------------------------------------

$server->wsdl->addComplexType(
    'Cdr',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'entity'  => array('name'=>'entity', 'type'=>'xsd:string'),
        'received'  => array('name'=>'received', 'type'=>'xsd:string'),
        'dialed'  => array('name'=>'dialed', 'type'=>'xsd:string'),
        'channel'  => array('name'=>'channel', 'type'=>'xsd:string'),
        'calldate'  => array('name'=>'calldate', 'type'=>'xsd:string'),
        'duration'  => array('name'=>'duration', 'type'=>'xsd:string')
    )
);

// ---- CDR[] ------------------------------------------------------

$server->wsdl->addComplexType(
    'CdrArray',
    'complexType',
    'array',
    '',
    'SOAP-ENC:Array',
    array(),
    array(
        array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Crd[]')
    ),
    'tns:Cdr'
);



?>
